/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
//
//
//	Perception学習開始URL作成クラス
//			変更履歴
// 2004.01.08 suzuki
//

package jp.co.ntt.lms.lo.Perception;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Calendar;
import java.net.URLEncoder;
import java.io.UnsupportedEncodingException;
import java.sql.SQLException;
import java.text.SimpleDateFormat;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.lo.Perception.util.CertificationCipher;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.*;
import jp.co.ntt.lms.xmo.People.PeopleClient;
import jp.co.ntt.lms.xmo.Groups.GroupsClient;
import jp.co.ntt.lms.xmo.GroupAndPeople.GroupAndPeopleClient;
import jp.co.ntt.lms.xmo.XMOTree;


/**
 * Perception学習開始URL作成クラス
 *
 * <PRE>
 *   PerceptionLoの学習開始URLを作成する。
 *   上位に学習開始URL作成インタフェースクラスを持つ。
 * </PRE>
 *
 */
public class PerceptionLoURLMaker
	implements PerceptionPropertyDef
{

// DEL start 2006.01.23 NTTR-an 
// PIPファイル切り替えのため、CALLパラメータをiniで指定する
// iniからの取得のため、本クラスのハードコード部分を削除	
//	private static final String CALL_VALUE = "xcalat2";
// DEL end
	
	private static final String ROOT_NAME = "XcalatⅡ-root";

	/**
	 * Perception学習開始URL作成
	 *
	 * @param Hashtable パラメータリスト
	 * @return String Perception学習開始URL
	 * @exception LOException Lo固有の例外エラー
	 */
	public String makeStartLearnURL(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException, Exception
	{
		try
		{
			// アセスメント開始URLを生成します
			StringBuffer sbURL = new StringBuffer();		// URL組み立て用
			StringBuffer sbACCESS = new StringBuffer();		// ACCESS組み立て用
			
			// Perception教材詳細情報を設定します
			setPerceptionLoData( htbParam );
			
			// Perception教材環境クラスのインスタンス化
			PerceptionLoEnv objEnv     = new PerceptionLoEnv();
			
			// Perception.iniより必要な情報を取得
			String strAssessmentRL = objEnv.getAssessmentURL();	// アセスメント開始URL
			String strLogCatcher = objEnv.getLogCatcherURL();	// ログキャッチャーURL
			String strExpireTime = objEnv.getExpireTime();		// session.dll呼び出し期限
			String strServerKey = objEnv.getServerKey();		// ServerKey
			
// ADD start 2006.01.23 NTTR-an 
// PIPファイル切り替えのため、CALLパラメータをiniで指定する
			String strCallValue = objEnv.getCallValue();
//ADD end
			// EXPIRESを算出し、成形する
			Calendar objExpireDate = Calendar.getInstance();
			objExpireDate.add(Calendar.HOUR, Integer.parseInt(strExpireTime));
			SimpleDateFormat formatter = new SimpleDateFormat ("dd:MM:yyyy:hh:mm");
			strExpireTime = formatter.format(objExpireDate.getTime());
			// アセスメントIDの取得
			String strAssessmentID = (String)htbParam.get( ASSESSMENT_ID );
			
			// ユーザIDの取得
			String strUserID = (String)htbParam.get( USER );
			
			// ユーザ名称の取得
			String strUserName = "";
			String strUserForeignID = "";
			PeopleClient objPeople = new PeopleClient();
			objPeople.setWhereUserID(strUserID);
			if( !objPeople.select() ) {
				// 検索がうまくいかなかった場合
				DebugLog.write(this.getClass(), "学習者名検索失敗", DebugLog.HIGHT);
			}
			else{
				while(objPeople.next())
				{
					strUserName = objPeople.getUserName();	// ユーザー名
					strUserForeignID = objPeople.getForeignID(); // ユーザ外部ID取得
				}
			}
			
			StringBuffer sbPathForURL = new StringBuffer();		// 階層（グループ名）
			StringBuffer sbPathForACCESS = new StringBuffer();	// 階層（グループ名）
			String strGroupID = "";
			String strGroupForeignID = "";
			String strGroupName = "";
			
			// ユーザのパスを最大10階層目まで取得（rootも含める）
			if( !strUserID.equals("PE000000") && strUserID != null ) {
				
				// strUserIDが指定されていた場合パスを取得する
				GroupAndPeopleClient objGandP = new GroupAndPeopleClient();
				if( !objGandP.searchPath(strUserID) ) {
					// パス検索がうまくいかなかった場合
					DebugLog.write(this.getClass(), "学習者パス検索失敗", DebugLog.HIGHT);
				}

				if( objGandP.next() ) {
					String[] strPath = objGandP.getPath();
					for( int i = 0; i < strPath.length-1; i++ ) {
						// 10階層を越えたらBreak
						if(i>10){
							break;
						}
						strGroupID = strPath[i];
						// 各階層のグループ名を取得
						GroupsClient objGroups = new GroupsClient();
						objGroups.setWhereGroupID( strGroupID );
						if( !objGroups.select() ) {
							// 検索がうまくいかなかった場合
							DebugLog.write(this.getClass(), "学習者名検索失敗", DebugLog.HIGHT);
						}
						else{
							while(objGroups.next())
							{
								strGroupName = objGroups.getGroupName();	// グループ名
							}
						}
						// rootの場合はグループ名を"XcalatⅡ-root"とする
						sbPathForURL.append("S");
						sbPathForURL.append(Integer.toString(i+1));
						sbPathForURL.append("=");
						if(i==0){
							sbPathForURL.append(URLEncoder.encode(ROOT_NAME, "UTF-8"));
							sbPathForACCESS.append(ROOT_NAME);
						}
						else{
							sbPathForURL.append(URLEncoder.encode(strGroupName, "UTF-8"));
							sbPathForACCESS.append(strGroupName);
						}
						sbPathForURL.append("&");
					}
					
					GroupsClient objGroups = new GroupsClient();
					strGroupID = strPath[strPath.length-2];
					objGroups.setWhereGroupID( strGroupID );
					if( !objGroups.select() ) {
						// 検索がうまくいかなかった場合
						DebugLog.write(this.getClass(), "グループ検索失敗", DebugLog.HIGHT);
					}
					else{
						while(objGroups.next())
						{
							strGroupForeignID = objGroups.getForeignID();	// 外部グループID
						}
					}
					
				}else{
				}
			}
			
			// ACCESS組み立て
// MOD start 2006.01.23 NTTR-an 
// PIPファイル切り替えのため、CALLパラメータをiniで指定する
//			sbACCESS.append(CALL_VALUE);
			sbACCESS.append(strCallValue);
// MOD end			
			sbACCESS.append(strAssessmentID);
			sbACCESS.append(strUserForeignID);
			sbACCESS.append(strGroupForeignID);	
			sbACCESS.append(strUserName);
			sbACCESS.append(strLogCatcher);
			sbACCESS.append(sbPathForACCESS.toString());
			sbACCESS.append(strExpireTime);
			sbACCESS.append(strServerKey);
			
			// ACCESSをMD5値とする
			String strAccess = CertificationCipher.encode(sbACCESS.toString());
			
			// URL組み立て
			sbURL.append(strAssessmentRL);
			sbURL.append("?");
			sbURL.append("CALL=");
// MOD start 2006.01.23 NTTR-an 
// PIPファイル切り替えのため、CALLパラメータをiniで指定する
//			sbURL.append(URLEncoder.encode(CALL_VALUE, "UTF-8"));
			sbURL.append(URLEncoder.encode(strCallValue, "UTF-8"));
// MOD end
			sbURL.append("&SESSION=");
			sbURL.append(URLEncoder.encode(strAssessmentID, "UTF-8"));
			sbURL.append("&NAME=");
			sbURL.append(URLEncoder.encode(strUserForeignID, "UTF-8"));	
			sbURL.append("&GROUP=");
			sbURL.append(URLEncoder.encode(strGroupForeignID, "UTF-8"));
			sbURL.append("&DETAILS=");
			sbURL.append(URLEncoder.encode(strUserName, "UTF-8"));
			sbURL.append("&USENOTIFY=");
			sbURL.append(URLEncoder.encode(strLogCatcher, "UTF-8"));
			sbURL.append("&");
			sbURL.append(sbPathForURL.toString());
			sbURL.append("EXPIRES=");
			sbURL.append(URLEncoder.encode(strExpireTime, "UTF-8"));
			sbURL.append("&ACCESS=");
			sbURL.append(URLEncoder.encode(strAccess, "UTF-8"));

			return sbURL.toString();
		}
		catch(LOException le)
		{
			throw le;
		}
		catch(SQLException se ) {
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new LOException( se.getMessage() );
		}
		catch(UnsupportedEncodingException e) {
			throw e;
		}		
	}

	/**
	 * Perception教材詳細情報を設定します
	 */
	private void setPerceptionLoData( Hashtable htbParam )
		throws LOException
	{

		// Dataアクセスクラスを使用して、詳細情報を取得する
		PerceptionLoDataAccess objDataAccess = new PerceptionLoDataAccess();
		PerceptionLoData[] objData = objDataAccess.getData( htbParam );

		for( int i = 0; i < objData.length; i++ ) {
			// ハッシュに必要な項目を設定
			// アセスメントIDの設定
			htbParam.put( ASSESSMENT_ID, objData[i].getAssessmentID() );
		}
	}
}

